%--------------------------------------------------------------------------
function [U,v] = FCM_gabi(F,c,iter)
%--------------------------------------------------------------------------
% tic
[m,n] = size(F);

mn = m*n;


f = reshape(F,mn,1);

x = (max(F(:))-min(F(:)))/c;
v=zeros(c,1);
for i = 1:c
    v(i) = (i - 1) * x + x / 2;
end

w = zeros(mn,c);
u = zeros(mn,c);  %nur als Speicherreservierung

%[sortedF,sind] = sort(f);
for k = 1:iter

    s = zeros(mn,1);
    p = ones(mn,c);

    for i = 1:c
        %median problem: will become 0 at the median component
        w(:,i) = abs((f - v(i) )).^2;
    end

    for i = 1:c
        for j = 1:c
            if j ~= i
                p(:,i) = p(:,i).*w(:,j);
            end
        end
        s = s + p(:,i);
    end
    for i = 1:c
        u(:,i) = p(:,i)./s;

        % calculate weighted median.
        %tW = u(:,i).^2;
        %tW = tW(sind);
        %norm(tW)
        %v(i) = weighted_median(sortedF,tW);
        v(i) = sum(u(:,i).^2.*f)/sum(u(:,i).^2);
    end
    
    %fprintf('it:%g\n',k);
end

U = reshape(u,m,n,c);

%[ U_cb, U_lab ] = assignlabel( U,v );

%figure(6);
%imagesc(U_cb);colormap(gray);axis square;
% toc
%--------------------------------------------------------------------------
function m = weighted_median(x, w, sortFlag)
%--------------------------------------------------------------------------
%
% x:                          
%   input data, column vector. If x is _not_ sorted you have to pass sortFlag = 1
%
% w:                          
%   weights have to be sorted corresponding to x
%
% sortFlag (optional parameter):    
%   Set to 1 if you pass unsorted data. Then sorting is done in this function. 
%

if nargin > 2 && sortFlag == 1
    [x,sortedInd] = sort(x);
    w = w(sortedInd);
end

n = size(x,1);

% calculate weighted median.
sum_1_n = sum(w);
for k =n:-1:1
    if sum_1_n - 2*sum(w(k:n)) < 0
        m = x(k);
        break;
    end
end



%--------------------------------------------------------------------------
function [ res_cb, res_lab ] = assignlabel( U,r )
%--------------------------------------------------------------------------
%
% Computes label of every pixel. Choses the label corresponding to the
% maximum value of U.
%
% INPUT
%
% U:    U(i,j) \in \R^Q
% r:    codebook
%
% OUTPUT
%
% res_cb:   Result with codebook values
% res_lab:  Result with label values

[maxv,res_lab] = max(U,[],3);
res_cb = r(res_lab);
