%--------------------------------------------------------------------------
function [res_cb, res_lab] = assignlabel(U,F,c)
%--------------------------------------------------------------------------
%   This program Computes label of every pixel. Choosing the label 
%      corresponding to the maximum value of U.
%    
%   Usage: [res_cb, res_lab] = assignlabel(U,F,c);
%
%   Inputs: 
%       - U: labels in continus domain
%       - F: given image
%       - c: codebook
%
%   Outputs: 
%       - res_cb:   result with codebook values
%       - res_lab:  result with label values
% 
%   Code by: Xiaohao Cai
%   Last updated: 20/07/2015 
%--------------------------------------------------------------------------


[maxv,res_lab] = max(U,[],3);

for i=1:c
    temp_num=double(res_lab==i);
    for j=1:3
        temp_value=temp_num.*F(:,:,j);
        m = sum(temp_value(:))/sum(temp_num(:));
        res_cb(:,:,j) = temp_num*m;
    end
    result_seg{i}=res_cb;
end

temp=result_seg{1}.*0;
for i=1:c
    temp=temp+result_seg{i};
end
res_cb=temp;
